Merge pull request #12785 from wtgodbe/DeleteTest
[platform/upstream/coreclr.git] / init-tools.sh
1 #!/usr/bin/env bash
2
3 __scriptpath=$(cd "$(dirname "$0")"; pwd -P)
4 __init_tools_log=$__scriptpath/init-tools.log
5 __PACKAGES_DIR=$__scriptpath/packages
6 __TOOLRUNTIME_DIR=$__scriptpath/Tools
7 __DOTNET_PATH=$__TOOLRUNTIME_DIR/dotnetcli
8 __DOTNET_CMD=$__DOTNET_PATH/dotnet
9 if [ -z "$__BUILDTOOLS_SOURCE" ]; then __BUILDTOOLS_SOURCE=https://dotnet.myget.org/F/dotnet-buildtools/api/v3/index.json; fi
10 export __BUILDTOOLS_USE_CSPROJ=true
11 __BUILD_TOOLS_PACKAGE_VERSION=$(cat $__scriptpath/BuildToolsVersion.txt)
12 __DOTNET_TOOLS_VERSION=$(cat $__scriptpath/DotnetCLIVersion.txt)
13 __BUILD_TOOLS_PATH=$__PACKAGES_DIR/microsoft.dotnet.buildtools/$__BUILD_TOOLS_PACKAGE_VERSION/lib
14 __INIT_TOOLS_RESTORE_PROJECT=$__scriptpath/init-tools.msbuild
15 __INIT_TOOLS_DONE_MARKER=$__TOOLRUNTIME_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/done
16
17 if [ -z "$__DOTNET_PKG" ]; then
18     if [ "$(uname -m | grep "i[3456]86")" = "i686" ]; then
19         echo "Error: build not supported on 32 bit Unix"
20         exit 1
21     fi
22 OSName=$(uname -s)
23     case $OSName in
24         Darwin)
25             OS=OSX
26             __DOTNET_PKG=dotnet-dev-osx-x64
27             ulimit -n 2048
28             ;;
29
30         Linux)
31             __DOTNET_PKG=dotnet-dev-linux-x64
32             OS=Linux
33             ;;
34
35         *)
36             echo "Unsupported OS '$OSName' detected. Downloading linux-x64 tools."
37             OS=Linux
38             __DOTNET_PKG=dotnet-dev-linux-x64
39             ;;
40   esac
41 fi
42
43 display_error_message()
44 {
45     echo "Please check the detailed log that follows." 1>&2
46     cat "$__init_tools_log" 1>&2
47 }
48
49 if [ ! -e $__INIT_TOOLS_DONE_MARKER ]; then
50     __PATCH_CLI_NUGET_FRAMEWORKS=0
51
52     if [ -e $__TOOLRUNTIME_DIR ]; then rm -rf -- $__TOOLRUNTIME_DIR; fi
53     echo "Running: $__scriptpath/init-tools.sh" > $__init_tools_log
54
55     if [ ! -e $__DOTNET_PATH ]; then
56
57         mkdir -p "$__DOTNET_PATH"
58
59         if [ -n "$DOTNET_TOOLSET_DIR" ] && [ -d "$DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION" ]; then
60             echo "Copying $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION to $__DOTNET_PATH" >> $__init_tools_log
61             cp -r $DOTNET_TOOLSET_DIR/$__DOTNET_TOOLS_VERSION/* $__DOTNET_PATH
62         elif [ -n "$DOTNET_TOOL_DIR" ] && [ -d "$DOTNET_TOOL_DIR" ]; then
63             echo "Copying $DOTNET_TOOL_DIR to $__DOTNET_PATH" >> $__init_tools_log
64             cp -r $DOTNET_TOOL_DIR/* $__DOTNET_PATH
65         else
66             echo "Installing dotnet cli..."
67             __DOTNET_LOCATION="https://dotnetcli.blob.core.windows.net/dotnet/Sdk/${__DOTNET_TOOLS_VERSION}/${__DOTNET_PKG}.${__DOTNET_TOOLS_VERSION}.tar.gz"
68             # curl has HTTPS CA trust-issues less often than wget, so lets try that first.
69             echo "Installing '${__DOTNET_LOCATION}' to '$__DOTNET_PATH/dotnet.tar'" >> $__init_tools_log
70             which curl > /dev/null 2> /dev/null
71             if [ $? -ne 0 ]; then
72                 wget -q -O $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
73             else
74                 curl --retry 10 -sSL --create-dirs -o $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
75             fi
76             cd $__DOTNET_PATH
77             tar -xf $__DOTNET_PATH/dotnet.tar
78
79             cd $__scriptpath
80
81             __PATCH_CLI_NUGET_FRAMEWORKS=1
82         fi
83     fi
84
85     if [ -n "$BUILD_TOOLS_TOOLSET_DIR" ] && [ -d "$BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION" ]; then
86         echo "Copying $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION to $__TOOLRUNTIME_DIR" >> $__init_tools_log
87         cp -r $BUILD_TOOLS_TOOLSET_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/* $__TOOLRUNTIME_DIR
88     elif [ -n "$BUILD_TOOLS_TOOL_DIR" ] && [ -d "$BUILD_TOOLS_TOOL_DIR" ]; then
89         echo "Copying $BUILD_TOOLS_TOOL_DIR to $__TOOLRUNTIME_DIR" >> $__init_tools_log
90         cp -r $BUILD_TOOLS_TOOL_DIR/* $__TOOLRUNTIME_DIR
91     else
92         if [ ! -e $__BUILD_TOOLS_PATH ]; then
93             echo "Restoring BuildTools version $__BUILD_TOOLS_PACKAGE_VERSION..."
94             echo "Running: $__DOTNET_CMD restore \"$__INIT_TOOLS_RESTORE_PROJECT\" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION" >> $__init_tools_log
95             $__DOTNET_CMD restore "$__INIT_TOOLS_RESTORE_PROJECT" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION >> $__init_tools_log
96             if [ ! -e "$__BUILD_TOOLS_PATH/init-tools.sh" ]; then
97                 echo "ERROR: Could not restore build tools correctly." 1>&2
98                 display_error_message
99             fi
100         fi
101
102         echo "Initializing BuildTools..."
103         echo "Running: $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR" >> $__init_tools_log
104
105         # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
106         chmod +x $__BUILD_TOOLS_PATH/init-tools.sh
107         $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR >> $__init_tools_log
108         if [ "$?" != "0" ]; then
109             echo "ERROR: An error occurred when trying to initialize the tools." 1>&2
110             display_error_message
111             exit 1
112         fi
113     fi
114
115     echo "Making all .sh files executable under Tools."
116     # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
117     ls $__scriptpath/Tools/*.sh | xargs chmod +x
118     ls $__scriptpath/Tools/scripts/docker/*.sh | xargs chmod +x
119
120     Tools/crossgen.sh $__scriptpath/Tools
121
122     touch $__INIT_TOOLS_DONE_MARKER
123
124     echo "Done initializing tools."
125 else
126     echo "Tools are already initialized"
127 fi